//---------------------------------------------------------------------------
// Bloody mode management
//---------------------------------------------------------------------------

#define   MAXBLOOD   5
Character *Blood[MAXBLOOD];
int       NextBlood = 0;

//-------------------------------------
// Load blood sprites
//-------------------------------------
int LoadBlood (u_long *memptr)
{
   int i;

   if ((*memptr) & 3)                                // LoadKRT
      *memptr = (((*memptr) + 4) & 0xFFFFFFFC);
   Blood[0] = (Character *)*memptr;
   *memptr += sizeof (Character);
   Blood[0]->Load ("\\SPRITES\\BLOOD.KRT", memptr);

   for (i = 1; i < MAXBLOOD; i++)
   {
      Blood[i] = Blood[0]->Clone_Character (0, memptr);
   }
}

//-------------------------------------
// Reintialize blood module
//-------------------------------------
void InitBlood (void)
{
   NextBlood = 0;
}

//-------------------------------------
// Draw the blood animations in the
// screen
//-------------------------------------
void DrawBlood (DoubleBuffer *db, int bkdx, int bkdy)
{
   int i;
   int dummy;

   for (i = 0; i < MAXBLOOD; i++)
      Blood[i]->DrawNextFrame (bkdx, bkdy, db, &dummy, &dummy, &dummy);
}

//-------------------------------------
// Add a new blood burst
//-------------------------------------
void AddBlood (int coorx, int coory, int typebld)
{
   Blood[NextBlood]->Set_Location (coorx, coory);
   Blood[NextBlood]->SetDepth (14);
   Blood[NextBlood]->StartAction (typebld & 1, 0);

   if (++NextBlood == 5)
      NextBlood = 0;
}
