//---------------------------------------------------------------------------
// Lethal Enforcers 2
// 
// Level        Mine
// Round        4
// Background   568, 240
// SetScale     0xffe8=5906, 0x39=1243
// Layers       255 57 18 18 18   17 10 0 -4 -5   -6 -21 -24 -24 -24
//---------------------------------------------------------------------------
// Sprites	Enemy Sets
// 		1   2   3   
// BGBLAK	X   X   X   
// BGJACK	X   X   X   
// BGMEXD	X   X   X   
// BGMEXS	X   X   X   
// BGMIKE	X   X   X   
// BGSTEV	X   X   X   
// BGTHIN	X   X   X   
// BMBOLF	        X   
// BWBONI	X   X       
// BWDEBI	        X   
// GMLAMP	        X   
// GWBLAK	    X       
// GWXYLA	X   X       
//---------------------------------------------------------------------------

// Define hit points
define BGBLAK_hp    2
define BGJACK_hp    2
define BGMEXD_hp    2
define BGMEXS_hp    2
define BGMIKE_hp    2
define BGSTEV_hp    2
define BGTHIN_hp    2
define BMBOLF_hp    2
define BWBONI_hp    1
define BWDEBI_hp    1
define GMLAMP_hp    1
define GWBLAK_hp    1
define GWXYLA_hp    1

// Define character literals
define BGBLAK1      0
define BGBLAK2      1
define BGBLAK3      2
define BGBLAK4      3
define BGJACK1      4
define BGJACK2      5
define BGJACK3      6
define BGJACK4      7
define BGJACK5      8
define BGMEXD1      9
define BGMEXD2      10
define BGMEXD3      11
define BGMEXD4      12
define BGMEXS1      13
define BGMEXS2      14
define BGMEXS3      15
define BGMEXS4      16
define BGMEXS5      17
define BGMEXS6      18
define BGMIKE1      19
define BGMIKE2      20
define BGMIKE3      21
define BGMIKE4      22
define BGMIKE5      23
define BGMIKE6      24
define BGMIKE7      25
define BGSTEV1      26
define BGSTEV2      27
define BGSTEV3      28
define BGSTEV4      29
define BGSTEV5      30
define BGSTEV6      31
define BGSTEV7      32
define BGSTEV8      33
define BGSTEV9      34
define BGSTEV10     35
define BGTHIN1      36
define BGTHIN2      37
define BGTHIN3      38
define BGTHIN4      39
define BGTHIN5      40
define BGTHIN6      41
define BMBOLF1      42
define BMBOLF2      43
define BWBONI1      44
define BWBONI2      45
define BWDEBI1      46
define BWDEBI2      47
define GMLAMP1      48
define GWBLAK1      49
define GWXYLA1      50
define GWXYLA2      51
define CART         52
define BUILDING     53
define EXPLODE      54
define RIFLE        55
define CAL50        56
define DYNA1        57
define DYNA2        58
define DYNA3        59
define DYNA4        60

// Define difficulty levels
define L1           0
define L2           1
define L3           2
define L4           3
define L5           4
define L6           5
define L7           6
define L8           7

// Define object characteristics
define ENEMY        0x0001    // Enemy
define VICTIM       0x0002    // Victim
define DISAPPEAR    0x0004    // Disappear when out of screen
define GUN          0x0008    // Gun (red contour)
define FALL         0x0010    // Fall, so check for collision
define WINDOW       0x0020    // Window (translucent)
define THROWN       0x0040    // Thrown object (zoom)
define START_ANIM   0x0080    // Can start another anim. over actual one
define ARROW        0x0100    // Arrow (do an arc)
define BLINK        0x0200    // Blink at the end
define SCROLL       0x0400    // We can scroll even though he's not dead
define BOSS         0x0800    // Boss
define VEH_SINUSOID 0x1000    // Vehicle (sinusoidal movement)
define VEH_LINEAR   0x2000    // Vehicle (linear movement)
define NOKILL       0x4000    // Can't be killed
define NODISPLAY    0x8000    // Don't display

// Define positions
// p01 (side from left)
define p01_x        247
define p01_y        185
define p01_l        12
define p01_scale    5906

// p02 (stand)
define p02_x        470
define p02_y        210
define p02_l        9
define p02_scale    4812

// p03 (stand)
define p03_x        520
define p03_y        210
define p03_l        9
define p03_scale    4812

// p04 (walk from left)
define p04_x        232
define p04_y        185
define p04_l        6
define p04_scale    3949

// p05 (walk from right)
define p05_x        578
define p05_y        185
define p05_l        6
define p05_scale    3949

// p06 (right side from building for small Rudy)
define p06_x        385
define p06_y        70
define p06_l        1
define p06_scale    1243

// p11 (stand)
define p11_x        56
define p11_y        200
define p11_l        8
define p11_scale    4755

// p12 (stand)
define p12_x        114
define p12_y        200
define p12_l        8
define p12_scale    4755

// p13 (side from right)
define p13_x        339
define p13_y        190
define p13_l        11
define p13_scale    5733

// p14 (low from pile)
define p14_x        276
define p14_y        190
define p14_l        7
define p14_scale    4524

// p15 (run from screen left)
define p15_x        337
define p15_y        185
define p15_l        6
define p15_scale    3949

// p21 (guys on cart)
define p21_x        -52
define p21_y        81
define p21_l        4
define p21_scale    3488

// pc (cart)
define pc0_y        99
define pc0_l        5
define pc1_x        0-(104/2)
define pc2_x        248+(104/2)
define pc3_x        248-(104/2)
define pc4_x        568+(104/2)

// pitem1 (rifle)
define pitem1_x     433
define pitem1_y     19
define pitem1_l     2
define pitem1_scale 1358

// pitem2 (50 caliber)
define pitem2_x     447
define pitem2_y     53
define pitem2_l     2
define pitem2_scale 1358


// Load backgrounds and sounds
LoadBKD \BACKGRND\LE2\MINE\MINE3.BKD	// Mine 3 & 4 backgrounds are swapped
SetBKDLoc 0 -248 0 0
LoadVAB \SOUNDFX\LE2\HIDEOUT.VAB

// Load characters
LoadKRT \SPRITES\LE2\MINE\BGBLAK.KRT              // Ch 0 - BGBLAK1   
SetScale BGBLAK1 p03_scale
SetTotalHitPoints BGBLAK1 BGBLAK_hp

CloneCharacter BGBLAK1                            // Ch 1 - BGBLAK2   
SetScale BGBLAK2 p13_scale
SetTotalHitPoints BGBLAK2 BGBLAK_hp

CloneCharacter BGBLAK1                            // Ch 2 - BGBLAK3   
SetScale BGBLAK3 p21_scale
SetTotalHitPoints BGBLAK3 BGBLAK_hp

CloneCharacter BGBLAK1                            // Ch 3 - BGBLAK4   
SetScale BGBLAK4 p21_scale
SetTotalHitPoints BGBLAK4 BGBLAK_hp

LoadKRT \SPRITES\LE2\MINE\BGJACK.KRT              // Ch 4 - BGJACK1   
SetScale BGJACK1 p03_scale
SetTotalHitPoints BGJACK1 BGJACK_hp

CloneCharacter BGJACK1                            // Ch 5 - BGJACK2   
SetScale BGJACK2 p02_scale
SetTotalHitPoints BGJACK2 BGJACK_hp

CloneCharacter BGJACK1                            // Ch 6 - BGJACK3   
SetScale BGJACK3 p13_scale
SetTotalHitPoints BGJACK3 BGJACK_hp

CloneCharacter BGJACK1                            // Ch 7 - BGJACK4   
SetScale BGJACK4 p21_scale
SetTotalHitPoints BGJACK4 BGJACK_hp

CloneCharacter BGJACK1                            // Ch 8 - BGJACK5   
SetScale BGJACK5 p21_scale
SetTotalHitPoints BGJACK5 BGJACK_hp

LoadKRT \SPRITES\LE2\MINE\BGMEXD.KRT              // Ch 9 - BGMEXD1   
SetScale BGMEXD1 p06_scale
SetTotalHitPoints BGMEXD1 BGMEXD_hp

CloneCharacter BGMEXD1                            // Ch 10 - BGMEXD2  
SetScale BGMEXD2 p12_scale
SetTotalHitPoints BGMEXD2 BGMEXD_hp

CloneCharacter BGMEXD1                            // Ch 11 - BGMEXD3  
SetScale BGMEXD3 p13_scale
SetTotalHitPoints BGMEXD3 BGMEXD_hp

CloneCharacter BGMEXD1                            // Ch 12 - BGMEXD4  
SetScale BGMEXD4 p21_scale
SetTotalHitPoints BGMEXD4 BGMEXD_hp

LoadKRT \SPRITES\LE2\MINE\BGMEXS.KRT              // Ch 13 - BGMEXS1  
SetScale BGMEXS1 p01_scale
SetTotalHitPoints BGMEXS1 BGMEXS_hp

CloneCharacter BGMEXS1                            // Ch 14 - BGMEXS2  
SetScale BGMEXS2 p02_scale
SetTotalHitPoints BGMEXS2 BGMEXS_hp

CloneCharacter BGMEXS1                            // Ch 15 - BGMEXS3  
SetScale BGMEXS3 p12_scale
SetTotalHitPoints BGMEXS3 BGMEXS_hp

CloneCharacter BGMEXS1                            // Ch 16 - BGMEXS4  
SetScale BGMEXS4 p12_scale
SetTotalHitPoints BGMEXS4 BGMEXS_hp

CloneCharacter BGMEXS1                            // Ch 17 - BGMEXS5  
SetScale BGMEXS5 p13_scale
SetTotalHitPoints BGMEXS5 BGMEXS_hp

CloneCharacter BGMEXS1                            // Ch 18 - BGMEXS6  
SetScale BGMEXS6 p21_scale
SetTotalHitPoints BGMEXS6 BGMEXS_hp

LoadKRT \SPRITES\LE2\MINE\BGMIKE.KRT              // Ch 19 - BGMIKE1  
SetScale BGMIKE1 p01_scale
SetTotalHitPoints BGMIKE1 BGMIKE_hp

CloneCharacter BGMIKE1                            // Ch 20 - BGMIKE2  
SetScale BGMIKE2 p02_scale
SetTotalHitPoints BGMIKE2 BGMIKE_hp

CloneCharacter BGMIKE1                            // Ch 21 - BGMIKE3  
SetScale BGMIKE3 p14_scale
SetTotalHitPoints BGMIKE3 BGMIKE_hp

CloneCharacter BGMIKE1                            // Ch 22 - BGMIKE4  
SetScale BGMIKE4 p13_scale
SetTotalHitPoints BGMIKE4 BGMIKE_hp

CloneCharacter BGMIKE1                            // Ch 23 - BGMIKE5  
SetScale BGMIKE5 p11_scale
SetTotalHitPoints BGMIKE5 BGMIKE_hp

CloneCharacter BGMIKE1                            // Ch 24 - BGMIKE6  
SetScale BGMIKE6 p21_scale
SetTotalHitPoints BGMIKE6 BGMIKE_hp

CloneCharacter BGMIKE1                            // Ch 25 - BGMIKE7  
SetScale BGMIKE7 p21_scale
SetTotalHitPoints BGMIKE7 BGMIKE_hp

LoadKRT \SPRITES\LE2\MINE\BGSTEV.KRT              // Ch 26 - BGSTEV1  
SetScale BGSTEV1 p05_scale
SetTotalHitPoints BGSTEV1 BGSTEV_hp

CloneCharacter BGSTEV1                            // Ch 27 - BGSTEV2  
SetScale BGSTEV2 p01_scale
SetTotalHitPoints BGSTEV2 BGSTEV_hp

CloneCharacter BGSTEV1                            // Ch 28 - BGSTEV3  
SetScale BGSTEV3 p04_scale
SetTotalHitPoints BGSTEV3 BGSTEV_hp

CloneCharacter BGSTEV1                            // Ch 29 - BGSTEV4  
SetScale BGSTEV4 p13_scale
SetTotalHitPoints BGSTEV4 BGSTEV_hp

CloneCharacter BGSTEV1                            // Ch 30 - BGSTEV5  
SetScale BGSTEV5 p15_scale
SetTotalHitPoints BGSTEV5 BGSTEV_hp

CloneCharacter BGSTEV1                            // Ch 31 - BGSTEV6  
SetScale BGSTEV6 p14_scale
SetTotalHitPoints BGSTEV6 BGSTEV_hp

CloneCharacter BGSTEV1                            // Ch 32 - BGSTEV7  
SetScale BGSTEV7 p21_scale
SetTotalHitPoints BGSTEV7 BGSTEV_hp

CloneCharacter BGSTEV1                            // Ch 33 - BGSTEV8  
SetScale BGSTEV8 p21_scale
SetTotalHitPoints BGSTEV8 BGSTEV_hp

CloneCharacter BGSTEV1                            // Ch 34 - BGSTEV9  
SetScale BGSTEV9 p21_scale
SetTotalHitPoints BGSTEV9 BGSTEV_hp

CloneCharacter BGSTEV1                            // Ch 35 - BGSTEV10 
SetScale BGSTEV10 p21_scale
SetTotalHitPoints BGSTEV10 BGSTEV_hp

LoadKRT \SPRITES\LE2\MINE\BGTHIN.KRT              // Ch 36 - BGTHIN1  
SetScale BGTHIN1 p04_scale
SetTotalHitPoints BGTHIN1 BGTHIN_hp

CloneCharacter BGTHIN1                            // Ch 37 - BGTHIN2  
SetScale BGTHIN2 p05_scale
SetTotalHitPoints BGTHIN2 BGTHIN_hp

CloneCharacter BGTHIN1                            // Ch 38 - BGTHIN3  
SetScale BGTHIN3 p11_scale
SetTotalHitPoints BGTHIN3 BGTHIN_hp

CloneCharacter BGTHIN1                            // Ch 39 - BGTHIN4  
SetScale BGTHIN4 p15_scale
SetTotalHitPoints BGTHIN4 BGTHIN_hp

CloneCharacter BGTHIN1                            // Ch 40 - BGTHIN5  
SetScale BGTHIN5 p21_scale
SetTotalHitPoints BGTHIN5 BGTHIN_hp

CloneCharacter BGTHIN1                            // Ch 41 - BGTHIN6  
SetScale BGTHIN6 p21_scale
SetTotalHitPoints BGTHIN6 BGTHIN_hp

LoadKRT \SPRITES\LE2\MINE\BMBOLF.KRT              // Ch 42 - BMBOLF1  
SetScale BMBOLF1 p21_scale
SetTotalHitPoints BMBOLF1 BMBOLF_hp

CloneCharacter BMBOLF1                            // Ch 43 - BMBOLF2  
SetScale BMBOLF2 p21_scale
SetTotalHitPoints BMBOLF2 BMBOLF_hp

LoadKRT \SPRITES\LE2\MINE\BWBONI.KRT              // Ch 44 - BWBONI1  
SetScale BWBONI1 p03_scale
SetTotalHitPoints BWBONI1 BWBONI_hp

CloneCharacter BWBONI1                            // Ch 45 - BWBONI2  
SetScale BWBONI2 p11_scale
SetTotalHitPoints BWBONI2 BWBONI_hp

LoadKRT \SPRITES\LE2\MINE\BWDEBI.KRT              // Ch 46 - BWDEBI1  
SetScale BWDEBI1 p21_scale
SetTotalHitPoints BWDEBI1 BWDEBI_hp

CloneCharacter BWDEBI1                            // Ch 47 - BWDEBI2  
SetScale BWDEBI2 p21_scale
SetTotalHitPoints BWDEBI2 BWDEBI_hp

LoadKRT \SPRITES\LE2\MINE\GMLAMP.KRT              // Ch 48 - GMLAMP1  
SetScale GMLAMP1 p21_scale
SetTotalHitPoints GMLAMP1 GMLAMP_hp
ObjectCharacteristics GMLAMP1 VICTIM|DISAPPEAR|SCROLL

LoadKRT \SPRITES\LE2\MINE\GWBLAK.KRT              // Ch 49 - GWBLAK1  
SetScale GWBLAK1 p11_scale
SetTotalHitPoints GWBLAK1 GWBLAK_hp
ObjectCharacteristics GWBLAK1 VICTIM|DISAPPEAR|SCROLL

LoadKRT \SPRITES\LE2\MINE\GWXYLA.KRT              // Ch 50 - GWXYLA1  
SetScale GWXYLA1 p02_scale
SetTotalHitPoints GWXYLA1 GWXYLA_hp
ObjectCharacteristics GWXYLA1 VICTIM|DISAPPEAR|SCROLL

CloneCharacter GWXYLA1                            // Ch 51 - GWXYLA2  
SetScale GWXYLA2 p12_scale
SetTotalHitPoints GWXYLA2 GWXYLA_hp
ObjectCharacteristics GWXYLA2 VICTIM|DISAPPEAR|SCROLL

LoadKRT \SPRITES\LE2\MINE\M4CART.KRT		  // Ch 52 - CART
ObjectCharacteristics CART SCROLL|NOKILL|START_ANIM

LoadKRT \SPRITES\LE2\MINE\M4BLDG.KRT              // Ch 53 - BUILDING
ObjectCharacteristics BUILDING SCROLL|NOKILL

LoadKRT \SPRITES\LE2\L2EXPL.KRT                   // Ch 54 - EXPLODE
ObjectCharacteristics EXPLODE DISAPPEAR|SCROLL|NOKILL

LoadKRT \SPRITES\LE2\L2GUNS.KRT                   // Ch 55 - RIFLE
ObjectCharacteristics RIFLE SCROLL|GUN
CloneCharacter RIFLE                              // Ch 56 - CAL50

LoadKRT \SPRITES\LE2\L2DYNA.KRT                   // Ch 57 - DYNA1
ObjectCharacteristics DYNA1 THROWN|ARROW|DISAPPEAR|SCROLL
CloneCharacter DYNA1                              // Ch 58 - DYNA2
CloneCharacter DYNA1                              // Ch 59 - DYNA3
CloneCharacter DYNA1                              // Ch 60 - DYNA4

	
// Special stuff
ObjectCharacteristics BGMEXD1 SCROLL	// Munchkin dude doesn't need to die
	
// Projectiles
AssignProjectile BGMEXD1 DYNA1
AssignProjectile BGMEXD2 DYNA2
AssignProjectile BGMEXD3 DYNA3
AssignProjectile BGMEXD4 DYNA4

// Link the guns
SetDepth BUILDING 1
SetDepth EXPLODE  3
SetDepth CAL50    2
SetDepth RIFLE    2
Link BUILDING BGMEXD1   0  0  0 0 449 64
Link EXPLODE  BGMEXD1   0  0  0 0 440 64
Link CAL50    BGMEXD1   3  0  1 0 440 55
Link RIFLE    BGMEXD1   2  0  1 1 440 75

PlayTrack 507 0                 // SD_BGM8

// Action!
define FC     0  // Frame Counter
StartActionXY BGMIKE1   5    p01_x    p01_y    p01_l FC+64    0 L1  // SIDE

StartActionXY CART      0      pc4_x    pc0_y    pc0_l FC+90   0 L1
MoveTo        CART             pc1_x    pc0_y    (pc4_x-pc1_x)  FC+90
//Attach        BGSTEV7   CART   6  0  FC+90+100  0  0  p21_l  L1
	
StartActionXY BGJACK1   6    p03_x    p03_y    p03_l FC+128   0 L1  // STND
StartActionXY BGMIKE2   3    p02_x    p02_y    p02_l FC+192   0 L5  // STND
StartActionXY BGTHIN1  17    p04_x    p04_y    p04_l FC+256   0 L1  // RUN
StartActionXY BGMEXS1  12    p01_x    p01_y    p01_l FC+320   0 L5  // SIDE
StartActionXY BGMEXD1   6    p06_x    p06_y    p06_l FC+336   1 L1  // 0x06
StartActionXY BGBLAK1   4    p03_x    p03_y-10 p03_l FC+384   0 L1  // STND
StartActionXY GWXYLA1   1    p02_x    p02_y    p02_l FC+448   0 L1  // STND
StartActionXY BGSTEV1  13    p05_x    p05_y    p05_l FC+512   0 L1  // RUN
StartActionXY BGJACK2  13    p02_x-10 p02_y-10 p02_l FC+576   1 L2  // LOW

StartActionXY CART      0      pc3_x    pc0_y    pc0_l FC+614   0 L1
MoveTo        CART             pc4_x    pc0_y    (pc4_x-pc3_x)  FC+614
	
StartActionXY BGSTEV2   8    p01_x    p01_y    p01_l FC+640   0 L5  // SIDE
StartActionXY BWBONI1   4    p03_x    p03_y-5  p03_l FC+704   0 L3  // STND
StartActionXY BGTHIN2  17    p05_x    p05_y    p05_l FC+768   1 L4  // RUN
StartActionXY BGMEXS2  14    p02_x    p02_y    p02_l FC+832   1 L4  // LOW
StartActionXY BGSTEV3  13    p04_x    p04_y    p04_l FC+896   1 L1  // RUN
ScrollBKDTo 0 0 0 124 FC+928

define FC  FC+928  // Frame Counter
StartActionXY BGSTEV4   8    p13_x    p13_y    p13_l FC+48    1 L1  // SIDE
StartActionXY BGTHIN3  10    p11_x    p11_y+5  p11_l FC+128   0 L5  // STND
StartActionXY BGMEXD2   4    p12_x    p12_y-10 p12_l FC+192   0 L1  // STND
StartActionXY BGMIKE3   5    p14_x    p14_y    p14_l FC+256   1 L6  // LOW
StartActionXY BGJACK3   8    p13_x    p13_y    p13_l FC+340   1 L2  // SIDE
StartActionXY BGMEXS3  10    p12_x    p12_y    p12_l FC+384   0 L5  // STND
StartActionXY BGSTEV5  13    p15_x    p15_y    p15_l FC+448   0 L7  // RUN
StartActionXY GWBLAK1   1    p11_x    p11_y    p11_l FC+512   0 L1  // STND
StartActionXY BGMIKE4   5    p13_x    p13_y    p13_l FC+576   1 L7  // SIDE
StartActionXY BGBLAK2   6    p13_x    p13_y    p13_l FC+640   1 L5  // SIDE
StartActionXY BWBONI2   4    p11_x    p11_y    p11_l FC+704   0 L1  // STND
StartActionXY BGMEXS4  10    p12_x    p12_y    p12_l FC+768   0 L6  // STND
StartActionXY BGSTEV6  10    p14_x-20 p14_y    p14_l FC+832   1 L3  // LOW
StartActionXY BGTHIN4  17    p15_x    p15_y    p15_l FC+896   1 L7  // RUN
StartActionXY BGMEXD3   6    p13_x    p13_y    p13_l FC+960   1 L3  // SIDE
StartActionXY GWXYLA2   1    p12_x    p12_y    p12_l FC+1024  0 L1  // STND
StartActionXY BGMIKE5   3    p11_x    p11_y    p11_l FC+1088  0 L4  // STND
StartActionXY BGMEXS5  12    p13_x    p13_y    p13_l FC+1152  1 L1  // SIDE
ScrollBKDTo 0 0 0 0 FC+1184

	
// Ore cart
define FC  FC+1184  // Frame Counter
////StartActionXY BGJACK4   6    p21_x    p21_y    p21_l FC+0     0 L1  // STND
////StartActionXY BGMIKE6   3    p21_x    p21_y    p21_l FC+0     0 L1  // STND
////StartActionXY BMBOLF1   5    p21_x    p21_y    p21_l FC+0     0 L1  // STND
////StartActionXY BGTHIN5  10    p21_x    p21_y    p21_l FC+0     0 L1  // STND
////StartActionXY BWDEBI1   4    p21_x    p21_y    p21_l FC+0     0 L1  // STND
////StartActionXY BGBLAK3   4    p21_x    p21_y    p21_l FC+0     0 L1  // STND
////StartActionXY BGTHIN6  10    p21_x    p21_y    p21_l FC+0     0 L1  // STND
////StartActionXY BGSTEV8   6    p21_x    p21_y    p21_l FC+0     0 L1  // STND
////StartActionXY BWDEBI2   4    p21_x    p21_y    p21_l FC+0     0 L1  // STND
////StartActionXY BMBOLF2   5    p21_x    p21_y    p21_l FC+0     0 L1  // STND
////StartActionXY BGMEXD4   4    p21_x    p21_y    p21_l FC+0     0 L1  // STND
////StartActionXY BGSTEV9   6    p21_x    p21_y    p21_l FC+0     0 L1  // STND
////StartActionXY BGJACK5   6    p21_x    p21_y    p21_l FC+0     0 L1  // STND
////StartActionXY GMLAMP1   1    p21_x    p21_y    p21_l FC+0     0 L1  // STND
////StartActionXY BGMIKE7   3    p21_x    p21_y    p21_l FC+0     0 L1  // STND
////StartActionXY BGMEXS6  10    p21_x    p21_y    p21_l FC+0     0 L1  // STND
////StartActionXY BGBLAK4   4    p21_x    p21_y    p21_l FC+0     0 L1  // STND
////StartActionXY BGSTEV10  6    p21_x    p21_y    p21_l FC+0     0 L1  // STND
ScrollBKDTo 0 0 0 0 FC+32

define FC  FC+32  // Frame Counter
EndRound FC+30
